(function() {
"use strict";

this.name           = "miningScript";
this.author         = "Docwild";
this.copyright      = "GNU GENERAL PUBLIC LICENSE";
this.licence        = "GNU GENERAL PUBLIC LICENSE V2";
this.description    = "Mining and yoursing, too";
this.version        = "1.0 beta 1";

let L = false;  //to tell where you are when it crashes

this.sysName = "";

this.systemAsteroidObjects = [];//an array of asteroidMine objects


this.peaceMusic   = "Little_Town_-_orchestral.ogg";
this.hostileMusic = "Action_Game_Theme.ogg";
this.inRangeMusic = "Hold_the_Line_0.ogg";

this.maxMines = 10;
this.minMines = 4;
//this.firstActTimer = [];

this.miningClaimedNumber = 0;

this.startUp = this.reset = function() {
    if (missionVariables.miningSystemAsteroids == null)
        missionVariables.miningSystemAsteroids = 0;

    if (L) log(this.name, "Initialising Mining OXP " + this.name);

    if (missionVariables.miningClaimedNumber == null)
        missionVariables.miningClaimedNumber = 0;

    this.miningClaimedNumber = missionVariables.miningClaimedNumber;
};

this.shipWillLaunchFromStation = function() {
    //Maybe the player loaded a saved game, started a new game or perhaps
    //this is a saved game which has never had this oxp before
    //There's no way of telling. Well, there is, and that's what the populate method is about.
    if (this.sysName == "")
        this.populate(); //maybe there are already known mines, so leave the sysName and the missionVariables.miningSystemAsteroids alone

    Sound.stopMusic(this.peaceMusic);
    Sound.stopMusic(this.hostileMusic);
    Sound.stopMusic(this.inRangeMusic);

    if (worldScripts.miningMethods.playerClaimedMines.length > 0)
        this.miningClaimedNumber = worldScripts.miningMethods.playerClaimedMines.length;
};

this.shipWillExitWitchspace = function() {
    //You can't load from witchspace    
    this.sysName = ""; //don't wanna set this yet
    for (let i = 0; i < this.systemAsteroidObjects.length; i++)    {
        let obji = this.systemAsteroidObjects[i];
        if ( obji.firstActTimer && obji.firstActTimer.isRunning ) {
            obji.firstActTimer.stop();
            delete obji.firstActTimer;
        }
        if ( obji.revealBeaconTimer && obji.revealBeaconTimer.isRunning ) {
            obji.revealBeaconTimer.stop();
            delete obji.revealBeaconTimer;
        }
    }

    this.systemAsteroidObjects = null; //let the garbage collector do something useful for a change
    for (let i = 0; i < this.maxMines; i++)    { //reset the perpetuity variables
        missionVariables["miningSystemPerp" + i] = null;
    }

    if (L) log(this.name, "EXIT systemAsteroidObjects = "+this.systemAsteroidObjects);
    missionVariables.miningSystemAsteroids = 0;

    if (worldScripts.miningMethods.playerClaimedMines.length > 0)
        this.miningClaimedNumber = worldScripts.miningMethods.playerClaimedMines.length;

    this.populate();//go
};

this.populate = function() {
    // Here we will decide if we already know about any asteroids
    // and act accordingly.

    // avoid the headache, for now, but interstellar mining might be profitable
    if ( system.isInterstellarSpace || system.sun.hasGoneNova ) return;

    let mm = worldScripts.miningMethods;

    if ( mm.playerClaimedMines.length == 0 )
        mm.playerClaimedMines = mm.makeArray(this.miningClaimedNumber, "miningPlayerClaimedID"); // may or may not be in this system

    if ( mm.playerClaimedUnitsPerDay.length == 0 ) {//pick an array, any array. Don't let me see it
        mm.buildClaimedArrays();

        if (L)
            log(this.name, "DONE WITH ARRAYS\nplayerClaimedposition length = " + mm.playerClaimedPositions.length.toString()
                    + "\nworldScripts.miningMethods.playerClaimedSysName length = " + mm.playerClaimedSysName.length.toString());
    }

    if ( missionVariables.miningSystemAsteroids > 0 && this.sysName == "" )    {
        if (L)
            log(this.name, "LOADING:this.systemAsteroids.length = " + this.systemAsteroidObjects.length);
        this.loadMines();
    }
    else if ( this.sysName == "" ) {
        if (L)
            log(this.name, "CALCULATING:this.systemAsteroids.length = 0");
        //if we had no system perp it means this is a maiden voyage for this oxp, it will be handled the same way as entering a new system
        this.calculateMines();
        //worldScripts.miningMethods.updateBeacons(null);
    }
    let mineObj = null;
    for ( let i = 0; i < mm.playerClaimedMines.length; i++ ) {
        mineObj = mm.getObject( mm.playerClaimedPositions[i] );
        if (mineObj) {
            mineObj.unitsPerDay = mm.playerClaimedUnitsPerDay[i];
            mineObj.timeSinceOwned = mm.playerClaimedTimeSinceOwned[i];
            mineObj.timeSinceVisited = mm.playerClaimedTimeSinceVisited[i];
            mineObj.defence = mm.playerClaimedDefence[i];
            mineObj.narcBonus = mm.playerClaimedNarcotics[i];
            mineObj.liqBonus = mm.playerClaimedLiquor[i];
            mineObj.producing = mm.playerClaimedProducing[i];
            mineObj.morality = mm.playerClaimedMorality[i];
        }
        else {
            if (L)
                log(this.name, "Failed to get mineObj, probably not in this system\tworldScripts.miningMethods.playerClaimedSysName = "+mm.playerClaimedSysName[i]);
        }

        let days = clock.days - mm.playerClaimedTimeSinceVisited[i];
        if ( mm.playerClaimedProducing[i] ) {
            if ( days > 3 && days < 8 ) {
                if ( mm.playerClaimedDefence[i] == false ) {
                    let prob = Math.floor(Math.random()*20) + 1;
                    if (prob > 15) mm.removeOwned(i);
                }
            }
            else if ( days > 7 && days < 31 ) {
                let prob = Math.floor( Math.random()*20 ) + 1;
                if ( prob > 13 ) {
                    mm.removeOwned(i);
                }
                else {
                    mm.playerClaimedDefence[i] = false;
                    mm.playerClaimedNarcotics[i] = false;
                    mm.playerClaimedLiquor[i] = false;
                    mm.playerClaimedUnitsPerDay[i] = 10;
                }
            }
            else if ( days > 30 ) {
                let prob = Math.floor( Math.random()*20 ) + 1;
                if ( prob > 10 ) {
                    mm.removeOwned(i);
                }
                else {
                    mm.playerClaimedProducing[i] = false;
                    mm.playerClaimedUnitsPerDay[i] = 0;
                }
            }
        }
    }
};

this.shipLaunchedFromStation = function(station) {
    for( let i = 0; i < this.systemAsteroidObjects.length; i++ ) {
        if (L) log(this.name, "delay = " + this.systemAsteroidObjects[i].lightSpeedDelay  + " i = " + i);
        //this.firstActTimer[i] = new Timer(worldScripts.miningScript, function() {this.systemAsteroidObjects[i].firstAct();} , this.systemAsteroidObjects[i].lightSpeedDelay, -1);
        this.systemAsteroidObjects[i].firstActTimer.start();
    }
};

this.calculateMines = function() {
    this.sysName = system.name;//once per system
    this.systemAsteroidObjects = [];

    //We have to check to see if this system has any owned asteroids in it
    if (L)
        log(this.name, "CALCULATE\tthis.sysName = " + this.sysName);

    let mm = worldScripts.miningMethods;

    let astObs = 0;
    //compare each of our saved mines against this one system mine, nesty loopy
    for ( let c = 0; c < mm.playerClaimedMines.length; c++ ) {
        //skip those that aren't here
        if ( system.name == mm.playerClaimedSysName[c] ) {
            //this is an asteroid which is owned by the player and is in this system
            let position = Vector3D( mm.playerClaimedPositions[c] );
            this.systemAsteroidObjects.push( new mm.asteroidMine("-OWNED", position, "slaveMineOwned") );//insatntiate, place object and store in array
            this.systemAsteroidObjects[ this.systemAsteroidObjects.length-1 ].firstActTimer.start();
            if (L)
                log(this.name, "in system systemAsteroidObjects = "+this.systemAsteroidObjects);
        }
        else {
            if (L) log(this.name, "Not in system. NEXT!");
        }
    }

    let sysNumberOwned = this.systemAsteroidObjects.length; //where we left off

    let systemAsteroidsX = Math.floor(Math.random()*this.maxMines) + 1;

    if (systemAsteroidsX < sysNumberOwned)
        systemAsteroidsX += sysNumberOwned; //ensure we have enough asteroids

    if (systemAsteroidsX > this.maxMines)
        systemAsteroidsX = this.maxMines; //but not too many

    if (systemAsteroidsX < this.minMines)
        systemAsteroidsX = this.minMines;//but definitely enough

    if (L) log(this.name, "sysNumberOwned = " + sysNumberOwned + " systemAsteroidsX = " + systemAsteroidsX);

    //add to end of array
    for ( let i = sysNumberOwned; i < systemAsteroidsX; i++ ) {
        let rndInt = Math.floor( Math.random()*4 ) + system.government + 1;
        let tag = "";

        //unlikely to find unclaimed in corporate states
        if ( rndInt > 5 ) {
            tag = "-CLAIMED";
        }
        else {
            rndInt = Math.floor(Math.random()*10)
            tag = rndInt <= 3 ? "-UNCLAIMED" : "-CLAIMED";
        }

        //gotta love oo, except c++ which sucks
        this.systemAsteroidObjects.push( new mm.asteroidMine(tag, null, "slaveMine") );

        if (L) log(this.name, "this.systemAsteroidObjects[i] = " + this.systemAsteroidObjects[i] + " tag = " + tag);

        this.systemAsteroidObjects[ this.systemAsteroidObjects.length-1 ].firstActTimer.start();
    }
};

this.loadMines = function() {
    // in my original, procedural code, this method was 50 lines.. you may now be impressed
    this.sysName = system.name; // if we have perpetuity then we know where we are

    let mm = worldScripts.miningMethods;

    // place system asteroids one at a time
    for ( let i = 0; i < missionVariables.miningSystemAsteroids; i++ ) {
        let position = mm.getPositionVector( missionVariables["miningSystemPerp" + i] ); // stored position
        let tag = mm.returnTag( missionVariables["miningSystemPerp" + i] );
        if (L)
            log(this.name, "tag = " + tag);
        if ( tag === "-OWNED" )
            this.systemAsteroidObjects.push( new mm.asteroidMine(tag, position, "slaveMineOwned" ));
        else
            this.systemAsteroidObjects.push( new mm.asteroidMine(tag, position, "slaveMine" ));
    }
};

this.shipDockedWithStation = function(station) {
    let mm = worldScripts.miningMethods;

    if ( station.isMainStation ) {
        if (L)
            log(this.name, "Main Station, setting perp variables and returning");
        missionVariables.miningClaimedNumber = this.miningClaimedNumber;
        mm.rebuildPerpVariables();
        return;
    }

    // Not in a main station, but is it a mine?
    if ( ! station.hasRole('slaveMineRock') ) return;

    for ( let i = 0; i < this.systemAsteroidObjects.length; i++ ) {
        if (L) log(this.name, "Docked with non-main station, checking type...\ni = " + i +"this.systemAsteroidObjects[i].minePos = " + this.systemAsteroidObjects[i].minePos + "station.position = " + station.position);
        let mineObj    = this.systemAsteroidObjects[i];
        let mineEntity = mineObj.get();

        if ( mineEntity != null && L ) log (this.name, "mineEntity = " + mineEntity);

        if ( station.position.distanceTo(mineEntity.position) > 1000 ) continue;

        Sound.stopMusic(this.inRangeMusic);
        //Sound.stopMusic(this.hostileMusic);
        mm.playerDetectFlag = false;
        if (L) log(this.name, "this is a mine");

        if ( mineObj.mineStatus === "-UNCLAIMED" ) {
            mineObj.takeOverMine();
            if (L) log(this.name, "Docked with UNCLAIMED: " + station.displayName);
        }
        else if ( mineObj.mineStatus === "-OWNED" ) {
            if (L) log(this.name, "Docked with OWNED");
            mineObj.vistingMine();
        }
        else if ( mineObj.mineStatus === "-CLAIMED" ) {
            if (L) log(this.name, "Docked with CLAIMED");

            let chanceFactor = Math.floor( Math.random()*10 );
            if ( chanceFactor > 4 ) {
                //someone elses
                //Sound.playMusic(hostileMusic, true);
                if (L) log(this.name, "... lucky");
                mineObj.takeOverMine();
            }
            else {
                let ps = player.ship;
                player.commsMessage("Power SPIKE.... NOOOOOOOOOOOOOOOOOOOOOOOOO\nGET OUT!");
                let delayLaunch = new Timer( this, function(){player.ship.launch();Sound.playMusic(hostileMusic, true);}, 5, -1 );

                let position = mineEntity.position;

                let delay = new Timer(this, function() {
                    let astObj = mm.getObject(position);
                    if (L) {
                        log(this.name, "player.ship.position = "+ps.position+" position = "+position+
                                        "\nplayer.ship.position.distanceTo(position) = "+ps.position.distanceTo(position));

                        log(this.name, "MINEOBJECT REMOVED: astObj.minePos = " + astObj.minePos);
                    }

                    astObj.removeFromArray(position);
                    mineEntity.explode();
                    //mm.rebuildPerpArray();
                    if ( ps.position.distanceTo(position) < 2000 ) {
                        ps.aftShield = parseInt(ps.maxAftShield/2);
                        ps.forwardShield = parseInt(ps.maxForwardShield/2);
                        //player.ship.inertia(player.ship.position.
                        //use the ship,inertia(Vector3D) to chuck ship like a cheating gf
                        player.consoleMessage("That was too close, commander....");
                    }
                    else {
                        if (L) log(this.name, "not close enough\tplayer.ship.position = "+ps.position+" position = "+position+
                                        "\nplayer.ship.position.distanceTo(position) = "+ps.position.distanceTo(position));
                    }
                }, 10, -1); //John Lee Hooker, getit?
            }
        }
    }
};

}).call(this);
